// File vpUart.h for CC1B
#ifndef _VPUART_H_
#define _VPUART_H_
//include other libraries here
#include <memory.h>
#include <Portpin.h>
#pragma library 1

#define vpUartRx(name,datapin,dataconfig,hspin,hsconfig,baud,ratio,format) \
#ifndef vpUartRx_installed \
#define vpUartRx_installed \
#endif \
#if (Baud_divide(baud,ratio) < 2) || (Baud_divide(baud,ratio) > 170) \
#error Specified baudrate not possible with supplied ratio \
#endif \
#pragma cdata. ##name##_inst = VP_UARTRX,10,(datapin)>>8,(datapin)&0xFF,Baud_divide(baud,ratio),format,0,0,0,0,(hspin)>>8,(hspin)&0xFF \
#pragma cdata. ##name##_pinconfig \
#if (datapin != 0) && (dataconfig != 0) \
#pragma cdata[] = (datapin)>>8,(datapin)&0xFF,dataconfig \
#endif \
#if (hspin != 0) && (hsconfig != 0) \
#pragma cdata[] = (hspin)>>8,(hspin)&0xFF,hsconfig \
#endif \
#pragma cdata[] = 0

#define vpUartTx(name,datapin,dataconfig,hspin,hsconfig,baud,ratio,format) \
#ifndef vpUartTx_installed \
#define vpUartTx_installed \
#endif \
#if (Baud_divide(baud,ratio) < 2) || (Baud_divide(baud,ratio) > 170) \
#error Specified baudrate not possible with supplied ratio \
#endif \
#pragma cdata. ##name##_inst = VP_UARTTX,10,(datapin)>>8,(datapin)&0xFF,Baud_divide(baud,ratio),format,0,0,0,0,(hspin)>>8,(hspin)&0xFF \
#pragma cdata. ##name##_pinconfig \
#if (datapin != 0) && (dataconfig != 0) \
#pragma cdata[] = (datapin)>>8,(datapin)&0xFF,dataconfig \
#endif \
#if (hspin != 0) && (hsconfig != 0) \
#pragma cdata[] = (hspin)>>8,(hspin)&0xFF,hsconfig \
#endif \
#pragma cdata[] = 0

shadowDef char vpUartRx_dport @0x10; //data port - lownib=5(RA) to 9(RE)
  shadowDef bit vpUartRx_dinvert @0x10.4; //invert
  shadowDef bit vpUartRx_docmode @0x10.5; //opencollector
shadowDef char vpUartRx_dpin @0x11; //pin bitmask (specified bit set , other bits cleared)
shadowDef char vpUartRx_baud @0x12; //baudrate
shadowDef char vpUartRx_format @0x13; //
  shadowDef bit vpUartRx_bits0 @0x13.0; //total bits: 01=9 10=10 11=11
  shadowDef bit vpUartRx_bits1 @0x13.1; //
  shadowDef bit vpUartRx_7bits @0x13.2; //set for 7 databits (0 = 8 databits)
  shadowDef bit vpUartRx_even @0x13.3; //set for even parity
  shadowDef bit vpUartRx_odd @0x13.4; //set for odd parity
  shadowDef bit vpUartRx_data @0x13.5; //set if valid value, cleared after value grabbed
  shadowDef bit vpUartRx_error @0x13.6; //set if parity error
  shadowDef bit vpUartRx_parity @0x13.7; //parity bit placeholder
shadowDef char vpUartRx_count @0x14; //number of bits
shadowDef char vpUartRx_divide @0x15; //timing counter
shadowDef char vpUartRx_low @0x16; //shift register
shadowDef char vpUartRx_high @0x17; //value
shadowDef char vpUartRx_hport @0x18; //handshake port - lownib=5(RA) to 9(RE)
  shadowDef bit vpUartRx_hinvert @0x18.4; //invert
  shadowDef bit vpUartRx_hocmode @0x18.5; //opencollector
shadowDef char vpUartRx_hpin @0x19; //pin bitmask (specified bit set , other bits cleared)

shadowDef char vpUartTx_dport @0x10; //data port - lownib=5(RA) to 9(RE)
  shadowDef bit vpUartTx_dinvert @0x10.4; //invert
  shadowDef bit vpUartTx_docmode @0x10.5; //opencollector
shadowDef char vpUartTx_dpin @0x11; //pin bitmask (specified bit set , other bits cleared)
shadowDef char vpUartTx_baud @0x12; //baudrate
shadowDef char vpUartTx_format @0x13; //
  shadowDef bit vpUartTx_bits0 @0x13.0; //total bits: 01=9 10=10 11=11
  shadowDef bit vpUartTx_bits1 @0x13.1; //
  shadowDef bit vpUartTx_7bits @0x13.2; //set for 7 databits (0 = 8 databits)
  shadowDef bit vpUartTx_even @0x13.3; //set for even parity
  shadowDef bit vpUartTx_odd @0x13.4; //set for odd parity
  shadowDef bit vpUartTx_data @0x13.5; //set if valid value, cleared after value grabbed
  shadowDef bit vpUartTx_error @0x13.6; //set if parity error
  shadowDef bit vpUartTx_parity @0x13.7; //parity bit placeholder
shadowDef char vpUartTx_count @0x14; //number of bits
shadowDef char vpUartTx_divide @0x15; //timing counter
shadowDef char vpUartTx_low @0x16; //shift register
shadowDef char vpUartTx_high @0x17; //value
shadowDef char vpUartTx_hport @0x18; //handshake port - lownib=5(RA) to 9(RE)
  shadowDef bit vpUartTx_hinvert @0x18.4; //invert
  shadowDef bit vpUartTx_hocmode @0x18.5; //opencollector
shadowDef char vpUartTx_hpin @0x19; //pin bitmask (specified bit set , other bits cleared)

/**
 * Isr code for virtual peripheral receive uart
 * This part only receives the serial bits.
 *
 * @param W physical ram bank address
 */
void vpUartRx_isr(char W) {
#pragma update_FSR 0 /* OFF */
  FSR = W;
  //rx_bit = rx_pin;
  W = vpUartRx_dport & 0x0F;
  FSR = W;
  _IsrTemp = INDF;
  FSR = _IsrBank;
  W = _IsrTemp;
  W &= vpUartRx_dpin;
  if (vpUartRx_dinvert) W ^= vpUartRx_dpin;
  Carry = 1;
  if (Zero_) Carry = 0;
  if (vpUartRx_count == 0) { // currently not receiving byte
    if (Carry == 0) { //rx_bit == 0
	  W = vpUartRx_format; //get total number of bits
	  W &= 0x03; //1, 2, 3
	  W |= 0x08; //9, 10, 11
      vpUartRx_count = W; //ready bits for start (9, 10, 11)
    }
	W = vpUartRx_baud >> 1;
	W += vpUartRx_baud;
    vpUartRx_divide = W;
  }
  vpUartRx_divide--;
  if (vpUartRx_divide == 0) {
    vpUartRx_divide = vpUartRx_baud;
    vpUartRx_count--;
    if (vpUartRx_count > 0) {
      //Carry = rx_bit;
      vpUartRx_low = rr(vpUartRx_low);    // process bit in Carry
      vpUartRx_parity = Carry; //save b0
    }
    else {
      vpUartRx_high = vpUartRx_low; //save byte to allow receive another byte
      vpUartRx_data = 1; //inform receiver has new data
    }
  }
#pragma update_FSR 1 /* ON */
}

/**
 * Isr code for virtual peripheral transmit uart
 * This part only transmits the serial bits.
 *
 * @param W physical ram bank address
 */
void vpUartTx_isr(char W) {
#pragma update_FSR 0 /* OFF */
  FSR = W;
  vpUartTx_divide--;
  if (vpUartTx_divide == 0) {
    if (vpUartTx_count) {
      Carry = 0;      // ready stop bit
	  if (vpUartTx_dinvert) Carry = 1;
      vpUartTx_high = rr(vpUartTx_high);    // shift to next bit
      vpUartTx_low = rr(vpUartTx_low);     // both bytes
      vpUartTx_count--;     // dec bit count
      if (vpUartTx_low.6) {
        //tx_pin = 0;  // if bit on, send zero
        W = ~vpUartRx_dpin;
	    _IsrTemp = W;
	    W = vpUartTx_dport & 0x0F;       //access RA to RE
	    if (vpUartTx_docmode) W |= 0xF0; //access DDRACOPY to DDRECOPY
	    FSR = W;
		W = _IsrTemp;
		INDF &= W; //update bit
      }
	  else {
        //tx_pin = 1;  //  if bit off, send 1
        W = vpUartRx_dpin;
	    _IsrTemp = W;
	    W = vpUartTx_dport & 0x0F;       //access RA to RE
	    if (vpUartTx_docmode) W |= 0xF0; //access DDRACOPY to DDRECOPY
	    FSR = W;
		W = _IsrTemp;
		INDF |= W; //update bit
	  }
      W = _IsrBank;
      FSR = W;
      if (vpUartTx_docmode) { //opencollector mode, so update chip DDR register
		vpUartTx_divide = MODE; //save M in void register
	    W = vpUartTx_dport | 0xF0; //access DDRACOPY to DDRECOPY
		FSR = W; //access bank 0xF0
		W &= 0x0F; //extract port
		switch (W) {
          case PORT_RA: DDRA = DDRACOPY;
		                break;
          case PORT_RB: DDRB = DDRBCOPY;
		                break;
#if defined _CHIP_SX28_ || defined _CHIP_SX48_ || defined _CHIP_SX52_
		  case PORT_RC: DDRC = DDRCCOPY;
		                break;
#endif
#if defined _CHIP_SX48_ || defined _CHIP_SX52_
          case PORT_RD: DDRD = DDRDCOPY;
		                break;
          case PORT_RE: DDRE = DDRECOPY;
		                break;
#endif
		}
        W = _IsrBank;
        FSR = W;
		MODE = vpUartTx_divide; //restore M
	  }
    }
    vpUartTx_divide = vpUartTx_baud;
	if (!vpUartTx_count) vpUartTx_data = 1; //inform transmitter is ready for new data
  }
#pragma update_FSR 1 /* ON */
}

/**
 * Calculate even parity for byte
 * Exit: _MainTemp.0 holds calculated parity
 *
 * @param W value for which to calculate even parity
 * @return calculated parity
 */
bit evenParity(char W) {
  _MainTemp = W;
  // calculation code by John Payson, as found on sxlist.com
  // This routine will leave the parity of _MainTemp in _MainTemp.0
  // while blenderizing most of the rest of _MainTemp
  W = swap(_MainTemp); //_MainTemp = abcdefgh
  _MainTemp ^= W;
  W = _MainTemp >> 1;
  _MainTemp ^= W;
  // at this point, the parity for half the bits (a,b,e,f) is in bit 2 of _MainTemp, and the
  // parity for the other half (c,d,g,h) is in bit 0 of _MainTemp.
  //	if the parity of (a,b,e,f) is 0, then the parity of (a,b,c,d,e,f,g,h)
  // is equal to the parity of (c,d,g,h)... which is already in bit 0, so skip ahead.
  if (_MainTemp.2) {
    // otherwise, the parity of (a,b,e,f) is 1, so the parity of (a,b,c,d,e,f,g,h) is
    // NOT equal to the parity of (c,d,g,h)... invert bit 0.
    _MainTemp++;
  }
  // at this point, bit 0 contains the parity of (a,b,c,d,e,f,g,h).
  return _MainTemp.0;
}

/**
 * Check if byte available
 *
 * @param W physical ram bank address
 * @return True if value available
 */
bit vpUartRx_byteAvailable(char W) {
#pragma update_FSR 0
  FSR = W;
  if (vpUartRx_data) return 1;
#pragma update_FSR 1
  return 0;
}

/**
 * Post-isr code for virtual peripheral receive uart
 * Exit: value in W
 * This part grabs a received byte and checks for parity error if required.
 * It controls the handshake pin in case the receive buffer is full.
 *
 * @param bnk physical ram bank address
 * @return received byte
 */
char vpUartRx_receiveByte(char bnk) {
  while (!vpUartRx_byteAvailable(bnk)) ; //wait until a byte is received
  W = bnk;
#pragma update_FSR 0
  FSR = W;
  Carry = vpUartRx_parity; //get last saved b0
  if (vpUartRx_format.1) goto uit1;
  Carry = 0; //adjust for 7 databits + no parity (total 9 bits)
  vpUartRx_high = rr(vpUartRx_high);
  vpUartRx_high = rr(vpUartRx_high);
uit1:
  if (vpUartRx_format.0) vpUartRx_high = rl(vpUartRx_high); //adjust for 8 databits + parity (total 11 bits)
  if (!vpUartRx_7bits) goto uit2;
  Carry = vpUartRx_high.7; //save possible parity in case 7 databits
  vpUartRx_high.7 = 0; //clear b7 in case 7 databits
uit2:
  vpUartRx_parity = Carry; //save possible paritybit
  vpUartRx_error = 0; //assume no error
  if (vpUartRx_odd) goto uit3;
  if (vpUartRx_even) goto uit3;
  goto uit4;
uit3:
  evenParity(vpUartRx_high);
  if (vpUartRx_odd) _MainTemp = !_MainTemp; //invert calculated paritybit for odd parity
  _MainTemp += vpUartRx_parity; //if parity matches, b0 will be cleared
  if (_MainTemp.0) vpUartRx_error = 1;
uit4:
  vpUartRx_data = 0; //mark byte grabbed
#pragma update_FSR 1
  return vpUartRx_high;
}

/**
 * Post-isr code for virtual peripheral receive uart
 * This part turns the handshake output pin (RTS) on (remote sender may transmit) or off
 *
 * @param vpram physical ram bank address
 * @param onoff 1 to turn RTS on, 0 to turn RTS off
 */
void vpUartRx_RTS(char vpram, char onoff) {
  long portpin;
  W = vpram;
#pragma update_FSR 0
  FSR = W;
  _MainTemp = vpUartRx_hport;
  W = vpUartRx_hpin;
#pragma update_FSR 1
  portpin.low8 = W;
  portpin.high8 = _MainTemp;
  if (_MainTemp) { //if using handshake
    writePin(portpin,onoff);
  }
}

/**
 * Post-isr code for virtual peripheral receive uart
 * This function returns the errorbit that is updated by vpUartRx_receiveByte()
 * so it should be called after vpUartRx_receiveByte() is called (only when parity is used).
 *
 * @param W physical ram bank address
 * @return errorbit updated by vpUartRx_receiveByte()
 */
bit vpUartRx_parityError(char W) {
#pragma update_FSR 0
  FSR = W;
  Carry = vpUartRx_error; //get error bit
#pragma update_FSR 1
  return Carry;
}

/**
 * Check if transmitter is busy.
 *
 * @param W physical ram bank address
 * @return True if busy
 */
bit vpUartTx_sendBufferEmpty(char W) {
#pragma update_FSR 0
  FSR = W;
  if (vpUartTx_count) return 0;
#pragma update_FSR 1
  return 1;
}

/**
 * Pre-isr code for virtual peripheral transmit uart
 * This part checks if the handshake input pin (CTS) allows sending.
 *
 * @param W physical ram bank address
 * @return True if CTS on or no handshake is used (transmitting allowed)
 */
bit vpUartTx_CTS(char W) {
  long portpin;
#pragma update_FSR 0
  FSR = W;
  _MainTemp = vpUartTx_hport;
  W = vpUartTx_hpin;
#pragma update_FSR 1
  portpin.low8 = W;
  portpin.high8 = _MainTemp;
  if (_MainTemp) { //if using handshake
    if (readPin(portpin)) return 0; //handshake input inactive (CTS off, not allowed to send)
  }
  return 1;
}

/**
 * Pre-isr code for virtual peripheral transmit uart
 * This part calculates parity if required for an outgoing byte.
 * It checks wether a byte may be transmitted.
 *
 * @param vpram physical ram bank address
 * @param W value to send
 * @return True if value sent
 */
bit vpUartTx_sendByte(char vpram, char W) {
  _MainTemp = W;
#pragma update_FSR 0
  FSR = vpram;
  if (vpUartTx_data) { //transmitter ready for new data
    if (!vpUartTx_CTS(vpram)) return 0; // handshake off, not allowed to transmit
    vpUartTx_high = _MainTemp;
    if (vpUartTx_7bits) vpUartTx_high.7 = 0; //if not 8 bits then clear b7 for parity calculation
    evenParity(vpUartTx_high);
    if (vpUartTx_7bits) vpUartTx_high.7 = 1; //if not 8 bits then ready stopbit
	if (!vpUartTx_odd) goto uot1;
	Carry = !_MainTemp.0;
	goto uot2;
uot1:
    if (!vpUartTx_even) goto uot3;
	Carry = _MainTemp.0;
uot2:
    if (!vpUartTx_7bits) goto uot4;
	vpUartTx_high.7 = Carry; //if 7 databits then move parity into b7
uot3:
    Carry = 1; //ready stopbit
uot4:
    vpUartTx_low.7 = 0; //setup startbit
	vpUartTx_high = rr(vpUartTx_high); //rotate in paritybit or stopbit
	vpUartTx_low = rr(vpUartTx_low);
	vpUartTx_high = ~vpUartTx_high; //inverted mode
	vpUartTx_low = ~vpUartTx_low;
	W = vpUartTx_format; //get total number of bits
	W &= 0x03; //1, 2 or 3
	W |= 0x08; //9, 10 or 11
	vpUartTx_count = W; //now uart vp starts to transmit
	vpUartTx_data = 0; //mark byte grabbed
	return 1;
  }
#pragma update_FSR 1
  return 0;
}

#pragma library 0
#endif
// End of file vpUart.h
